// FileDemoView.cpp : implementation of the CFileDemoView class
//

#include "stdafx.h"
#include "FileDemo.h"

#include "FileDemoDoc.h"
#include "FileDemoView.h"
#include ".\filedemoview.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CFileDemoView

IMPLEMENT_DYNCREATE(CFileDemoView, CView)

BEGIN_MESSAGE_MAP(CFileDemoView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
    ON_COMMAND(ID_EDIT_CHANGEMESSAGE, OnEditChangemessage)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()

// CFileDemoView construction/destruction

CFileDemoView::CFileDemoView()
: m_bReadRegistry(true)
{
	// TODO: add construction code here

}

CFileDemoView::~CFileDemoView()
{
}

BOOL CFileDemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CFileDemoView drawing

void CFileDemoView::OnDraw(CDC* pDC)
{
	CFileDemoDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

    pDC->TextOut(20, 20, pDoc->m_message);
}


// CFileDemoView printing

BOOL CFileDemoView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CFileDemoView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CFileDemoView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CFileDemoView diagnostics

#ifdef _DEBUG
void CFileDemoView::AssertValid() const
{
	CView::AssertValid();
}

void CFileDemoView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFileDemoDoc* CFileDemoView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFileDemoDoc)));
	return (CFileDemoDoc*)m_pDocument;
}
#endif //_DEBUG


// CFileDemoView message handlers

void CFileDemoView::OnEditChangemessage()
{
   CTime now = CTime::GetCurrentTime();
   CString changetime = now.Format("Changed at %B %d %H:%M:%S");
   GetDocument()->m_message = changetime;
   GetDocument()->SetModifiedFlag();
   Invalidate();
}

void CFileDemoView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	// TODO: Add your specialized code here and/or call the base class
	Invalidate();
}


void CFileDemoView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// TODO: Add your specialized code here and/or call the base class
	if (m_bReadRegistry) {
		GetDocument()->m_message = AfxGetApp()->GetProfileString("File Demo", "Message");
		m_bReadRegistry = false;
	}
}

void CFileDemoView::OnDestroy()
{
	CView::OnDestroy();

	// TODO: Add your message handler code here
	AfxGetApp()->WriteProfileString("File Demo", "Message", GetDocument()->m_message);
}

void CFileDemoView::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	CMenu menu;
	menu.LoadMenu(IDR_MAINFRAME);
	menu.GetSubMenu(2)->TrackPopupMenu(TPM_LEFTALIGN, point.x, point.y, pFrame);}
